---
layout: default
title: Contribute to GitLab
description: "Learn how to contribute to GitLab. This page includes how to get started, how to get help, guidelines, process, and more."
canonical_path: "/community/contribute/"
suppress_header: true
extra_css:
  - contributing.css
  - community.css
  - bl-modal.css
  - video-carousel.css
extra_js:
  - libs/slick.min.js
  - video-carousel.js
---
.wrapper
  .simple-header
    %h1 Contribute to GitLab
    %p
    :markdown
      The next [GitLab Hackathon](https://about.gitlab.com/community/hackathon/) is just around the corner!
  #content
    .wrapper.container.contributing-content{role: "main"}
      .block
        .block-content
          %h2.block-title 
          %p
            We want to make it as easy as possible for GitLab users to become GitLab contributors, so we created this contribution guide to help you get started. You will find step-by-step instructions to contribute to development, documentation, translation, and design.
          %p  
            = link_to "Diversity, Inclusion, and Belonging", "/handbook/values/#diversity-inclusion"
            is one of our values. We want to create a welcoming community for every contributor. Please visit our
            = link_to "Code of Conduct page", "/community/contribute/code-of-conduct/"
            to learn more about our commitment to an open and welcoming environment.        
     

      .block
        .block-content
          %h2#get-started.block-title Get started
          %h4.text-center
            Choose a track to find step-by-step instructions on how to contribute.  
          .row.flex-row.area-row
            -data.contribute_page.each do |area|
              .col-md-4
                %h2.area-name
                  = area.category
                %p.area-description
                  = area.description
                .row.area-more
                  = link_to area.link_text, area.link

      .row.flex-row.area-row
        %h2.u-margin-bottom-sm.text-center
          Everyone can contribute
        .video-slider
          - data.video_carousel.each do |video|
            -if video.carousel_identifier.include?("Community Contribute Carousel 1")
              = partial "includes/components/video-carousel/video-item.html.haml", locals: {name: video.name, title: video.title, company: video.company, photourl: video.photourl, videolink: video.video_link}

        - data.video_carousel.each do |video|
          -if video.carousel_identifier.include?("Community Contribute Carousel 1")
            = partial "includes/components/video-carousel/video-carousel-modal.html.haml", locals: {videolink: video.video_link, title: video.title, photourl: video.photourl}


      .block
        .block-content
          %h2#getting-help.block-title Get Help
          :markdown
            If you need any help while contributing to GitLab, below are some of the resources that are available.

            1. Ask questions on the [Contributors Gitter Channel](https://gitter.im/gitlabhq/contributors).
            1. Get in touch with [Merge Request Coaches](/job-families/expert/merge-request-coach/). To find a merge request coach, go to the [GitLab Team Page](/team/) and search for "merge request coach". You can also [mention](https://docs.gitlab.com/ee/user/group/subgroups/#mentioning-subgroups) Merge Request Coaches by typing `@gitlab-org/coaches` in a comment.
            1. Find reviewers & maintainers of Gitlab projects in our [handbook](/handbook/engineering/projects/#gitlab-ce) and [mention](https://docs.gitlab.com/ee/user/group/subgroups/#mentioning-subgroups) them in a comment.
            1. If you have feature ideas/questions, you can search for existing issues or create a new issue if there isn't one already. Feel free to [mention](https://docs.gitlab.com/ee/user/group/subgroups/#mentioning-subgroups) [product team members](/handbook/product/categories/#devops-stages) in the issue.
            1. For any other questions or feedback, please email `contributors@gitlab.com`.

      .block
        .block-content.text-center
          %h2.block-title Community Contribution Metrics
          %p
            You can see the wider community contribution data in our
            = link_to "community dashboard", "https://gitlab.biterg.io/goto/937475d38035f496df3501c9b30af5ef"
            as well as the number of
            = link_to "wider community contributions per milestone.", "https://gitlab.biterg.io/app/kibana#/dashboard/465b66f0-882a-11e9-b37c-9d3431060b53?embed=true&_g=(refreshInterval:(display:Off,pause:!f,value:0),time:(from:now-10y,interval:'1w',mode:relative,timezone:America%2FLos_Angeles,to:now))&_a=(description:'',filters:!(),fullScreenMode:!f,options:(darkTheme:!f,hidePanelTitles:!f,useMargins:!t),panels:!((gridData:(h:24,i:'1',w:48,x:0,y:0),id:'43858010-8829-11e9-b37c-9d3431060b53',panelIndex:'1',type:visualization,version:'6.8.6')),query:(language:lucene,query:''),timeRestore:!t,title:'Wider+community+contributions+merged+per+milestone',viewMode:view))"

          :markdown 
            ![Community growth numbers](/images/community/wider-community-growth-2019.png){: .medium}<br>

            <!-- Note: The embeds here are not working due to a cross-site issue -->
            <!-- <embed width="100%" height="100%" style="min-height:300px;" src="https://gitlab.biterg.io/app/kibana#/dashboard/465b66f0-882a-11e9-b37c-9d3431060b53?embed=true&_g=(refreshInterval:(display:Off,pause:!f,value:0),time:(from:now-10y,interval:'1w',mode:relative,timezone:America%2FLos_Angeles,to:now))&_a=(description:'',filters:!(),fullScreenMode:!f,options:(darkTheme:!f,hidePanelTitles:!f,useMargins:!t),panels:!((gridData:(h:24,i:'1',w:48,x:0,y:0),id:'43858010-8829-11e9-b37c-9d3431060b53',panelIndex:'1',type:visualization,version:'6.8.6')),query:(language:lucene,query:''),timeRestore:!t,title:'Wider+community+contributions+merged+per+milestone',viewMode:view)"> -->
            <!-- <embed width="100%" height="100%" style="min-height:300px;" src="https://app.periscopedata.com/app/gitlab/593556/Wider-Community-Dashboard?widget=7765561&udv=0"> -->
            <br>

        .newsletter-form-content
        %h4.block-title 🚀 Sign up for our newsletter
        %script{src: "//page.gitlab.com/js/forms2/js/forms2.min.js"}
        %form#mktoForm_1073
        :javascript
          MktoForms2.setOptions(
          {
            formXDPath : "/rs/194-VVC-221/images/marketo-xdframe-relative.html"
          });
          MktoForms2.loadForm("//page.gitlab.com", "194-VVC-221", 1073, function(form) {
            form.onSuccess(function(values, followUpUrl) {
              let formHasFormBeenFocused = false;
              form.onValidate(function() {
                if(formHasFormBeenFocused == false) {
                  dataLayer.push({
                    'event' : 'mktoLead', 
                    'mktoFormId' : form.getId(),
                    'eventCallback' : function()
                    {}, 'eventTimeout' : 3000
                  });
                  formHasFormBeenFocused = true;
                  return false;
                };
              });
              dataLayer.push({
                'event' : 'mktoLead', 
                'mktoFormId' : form.getId(),
                'eventCallback' : function()
                {
                  form.getFormElem().hide();
                  document.getElementById('confirmformnewlsetter').style.visibility = 'visible';
                }, 'eventTimeout' : 3000
              });
              return false;
            });
            function getgacid() {
              try {
                var tracker = ga.getAll()[0];
                return tracker.get('clientId');
              } catch (e) {
                return 'n/a';
              }
            }
            form.vals({
              'gacid': getgacid()
            });
          });
        #confirmformnewlsetter{style: "visibility:hidden;"}
          %p.thanks-subscribing
            Thanks for subscribing!
            %a{href: "https://www.twitter.com/gitlab", target: "_blank"}
              Follow us on twitter
            for even more updates!
